#include<bits/stdc++.h>
using namespace std;

#define REP(i, n) for(int i=0; i<(n); ++i)
#define FOR(i, a, b) for(int i=(a); i<=(b); ++i)
#define FORD(i, a, b) for(int i=(a); i>=(b); --i)

#define ll long long
#define vi vector<int>
#define pii pair<int, int>
#define mp make_pair

const int INF = 1<<29;

#define MAXN 111111
int N;
vector<int> graph[MAXN];
int father[MAXN];
int sz[MAXN];

int dfs(int v, int f) {
  sz[v] = 1;
  REP(i, graph[v].size()) if (graph[v][i] != f) sz[v] += dfs(graph[v][i], v);
  return sz[v];
}

queue<int> vertices[MAXN];
void dfs2(int v, int f, int C) {
  vertices[C].push(v);
  REP(i, graph[v].size()) if (graph[v][i] != f) dfs2(graph[v][i], v, C);
}

int p[MAXN];

int main() {
  while(scanf("%d", &N) == 1) {
    REP(i, N) graph[i].clear();
    REP(i, N - 1) {
      scanf("%d", father + i + 1); 
      graph[i + 1].push_back(father[i + 1]);
      graph[father[i + 1]].push_back(i + 1);
    }
    REP(i, N) sz[i] = 0;
    dfs(0, -1);
    // REP(i, N) printf(" %d", sz[i]); printf("\n");
    int x = -1;
    REP(i, N) {
      bool ok = true;
      REP(j, graph[i].size()) if (graph[i][j] != father[i] && sz[graph[i][j]] > N / 2) ok = false;
      // printf("i: %d ok: %d\n", i, (int)ok);
      if (N - sz[i] > N / 2) ok = false;
      if (ok) { x = i; break; }
    }
    // printf("%d\n", x);

    int C = graph[x].size();

    REP(i, graph[x].size()) dfs2(graph[x][i], x, i);
    p[x] = 0;

    vector<pair<int, int> > v;
    REP(i, C) v.push_back(make_pair(vertices[i].size(), i));
    sort(v.begin(), v.end());
    reverse(v.begin(), v.end());
    int last = -1;
    REP(i, N - 1) {
      int start = 0;
      if (last == 0) start = 1; 
      int j;
      for (j = start; j < C; ++j) if (j == C - 1 || v[j].first > v[j + 1].first) break;
      // printf("(j=%d)", j);
      p[vertices[v[j].second].front()] = i + 1;
      vertices[v[j].second].pop();
      v[j].first--;
      last = j;
    }
    REP(i, N) { if(i) printf(" "); printf("%d", p[i]); }
    printf("\n");
  }
  return 0;
}
